template <typename T>
T contribution (const mesh<T>& Th, size_t i1, size_t j1, size_t k1,
	size_t i2, size_t j2, size_t k2) {
  	return (Th.vertice(k1)[0]-Th.vertice(j1)[0])*(Th.vertice(k2)[0]-Th.vertice(j2)[0])
             + (Th.vertice(k1)[1]-Th.vertice(j1)[1])*(Th.vertice(k2)[1]-Th.vertice(j2)[1]);
}
template <typename T>
void assembly_energy (const mesh<T>& Th, const std::valarray<size_t>& num, matrix<T>& a) {
	matrix_store<T> as (Th.n_internal_vertice(), Th.n_internal_vertice());
  	for (size_t l = 0; l < Th.size(); l++) {
    	    T coef  = 1/(4*Th.meas(l));
    	    for (size_t r = 0; r < 3; r++) {
              size_t i = Th[l][r];
              size_t j = Th[l][(r+1) % 3];
              size_t k = Th[l][(r+2) % 3];
              if (Th.is_internal(i)) { 
                as.entry (num[i],num[i])   += coef*contribution (Th, i,j,k, i,j,k);
                if (Th.is_internal(j))
                  as.entry (num[i],num[j]) += coef*contribution (Th, i,j,k, j,k,i);
                if (Th.is_internal(k))
                  as.entry (num[i],num[k]) += coef*contribution (Th, i,j,k, k,i,j);
              }
      	    }
  	}
	convert (as, a);
}
