#include "matrix.h"
template <typename T>
class diag {
  public:
    diag(const matrix<T>&);
    std::valarray<T> solve (const std::valarray<T>&) const;
  protected:
    std::valarray<T> d;
};
template <typename T>
diag<T>::diag(const matrix<T>& a)
 : d(T(), std::min(a.nrow(),a.ncol()))
{
  for (size_t i = 0; i < d.size(); i++)
    for (size_t p = a.ptr[i]; p < a.ptr[i+1]; p++)
      if (i == a.idx[p])
        d[i] = a.val[p];
}
template <typename T>
std::valarray<T> diag<T>::solve (const std::valarray<T>& b) const
{
  std::valarray<T> x (b.size());
  for (size_t i = 0; i < b.size(); i++)
    x[i] = b[i]/d[i];
  return x;
}
