// ---------------------------------------------------------------------------
// array with promote
// ---------------------------------------------------------------------------
#include <valarray>
#include <complex>
class undefined { };
template <typename T1, typename T2> struct promote { typedef undefined type; };
template <> struct promote<float,double> { 
		   typedef double type; };
template <> struct promote<double,double> { 
		   typedef double type; };
template <> struct promote<std::complex<double>,double> {
		   typedef std::complex<double> type; };
template <> struct promote<double,std::complex<double> > {
		   typedef std::complex<double> type; };
template <> struct promote<std::complex<double>,std::complex<double> > {
		   typedef std::complex<double> type; };
// ---------------------------------------------------------------------------
// array
// ---------------------------------------------------------------------------
#include <vector>
template <typename T>
class array : public std::vector<T> {
  public:
    array (size_t n = 0, const T& initval = T())
      : std::vector<T>(n,initval) {}
    size_t size() const { return std::vector<T>::size(); }
};
template <typename T1, typename T2>
array<typename promote<T1,T2>::type>
operator+ (const array<T1>& x, const array<T2>& y) {
  array<typename promote<T1,T2>::type> z (x.size());
  for (size_t i = 0; i < x.size(); i++)
    z [i] = x[i] + y[i];
  return z;
}
template<typename T1, typename T2>
std::complex<typename promote<T1,T2>::type>
operator+ (const std::complex<T1>& a, const std::complex<T1>& b)
{
  return std::complex<typename promote<T1,T2>::type>(
		  a.re()+b.re(), a.im()+b.im());
}

#include <iostream>
using namespace std;
int main () {
  size_t n = 5;
  array<double> x(n, 1);
  complex<double> i (0,1);
  array<complex<double> > y(n, i), z(n);
  z = x + y;
  for (size_t j = 0; j < z.size(); j++)
	    cout << j << " " << z [j] << endl;
  complex<float> z1;
  complex<double> z2;
  complex<double> z3;
#ifdef TODO
  z3 = z1 + z2;  // chec
  // complex<double> i(0,1);
  valarray<complex<double> > u1 (i, 10);
  valarray<double>           u2 (1, 10);
  valarray<complex<double> > u3 = u1 + u2; // chec...
#endif // TODO
}
