set terminal latex
set output "fd-cvg-h.tex"

set size square
set logscale
set ytics (                             \
        "[r]{$10^{-5}$}"   1e-5,        \
        "[r]{$10^{-4}$}"   1e-4,        \
        "[r]{$10^{-3}$}"   1e-3,        \
        "[r]{$10^{-2}$}"   1e-2,        \
        "[r]{$10^{-1}$}"   1e-1,        \
        "[r]{$1$}"   	   1e+0        \
        )
set xtics (                             \
        "{$1$}"   	1e0,        \
        "{$10^{1}$}"   1e1,        \
        "{$10^{2}$}"   1e2,        \
        "{$10^{3}$}"   1e3,        \
        "{$10^{4}$}"   1e4,        \
        "{$10^{5}$}"   1e5        \
        )
set xlabel "{\\large $n$}"
set  label "[l]{uniforme}" at graph 0.5,0.77
set  label "[r]{adapt\\'e}" at graph 0.5,0.45
set  label "[r]{\\large $\\|u_h-\\pi_hu\\|_{L^\\infty}$}" at graph -0.15,0.5
plot  [1:1e+5][1e-5:1]	\
	'fd-cvg-uniforme.dat' notitle w lp lt 1 pt 6, \
	'fd-cvg-adapte.dat'   notitle w lp lt 1 pt 10

#pause -1 "<retour>"

