#include <valarray>
struct fd_ssor_2d {
	template <typename T>
	std::valarray<T> solve (const std::valarray<T>& b) const;
	fd_ssor_2d (size_t n);
	size_t n;
};
fd_ssor_2d::fd_ssor_2d (size_t n1) : n(n1) {}

template <typename T>
std::valarray<T> fd_ssor_2d::solve (const std::valarray<T>& b) const {
        std::valarray<T> x (b.size());
	x[0] = b[0];
        for (size_t i = 1; i < n; i++)
            x[i] = b[i] + x[i-1]/2;
        for (size_t j = 1; j < n; j++) {
	    size_t nj = n*j;
	    size_t nj1 = n*(j-1);
	    x[nj] = b[nj] + x[nj1]/2;
	    for (size_t i = 1; i < n; i++)
	      x[i+nj] = b[i+nj] + (x[i+nj1] + x[i-1+nj])/2;
	}
	size_t nj = n*(n-1);
        x[n-1+nj] /= 2;
        for (size_t i = n-1; i > 0; i--)
            x[i-1+nj] = (x[i-1+nj] + x[i+nj])/2;
	for (size_t j = n-1; j > 0; j--) {
	    x[n-1+n*(j-1)] = (x[n-1+n*(j-1)] + x[n-1+n*j])/2;
	    for (size_t i = n-1; i > 0; i--)
	      x[i-1+n*(j-1)] = (x[i-1+n*(j-1)] + x[i+n*(j-1)] + x[i-1+n*j])/2;
	}
	return x;
}
