set terminal latex
set output "finite_element_cout.tex"

set logscale
set size square
set ytics (                		\
        "[r]{$10^{1}$}"   1e+1,        \
        "[r]{$10^{2}$}"   1e+2,        \
        "[r]{$10^{3}$}"   1e+3         \
        )
set xtics (                		\
        "{$10^{1}$}"   1e+1,        \
        "{$10^{2}$}"   1e+2,        \
        "{$10^{3}$}"   1e+3,        \
        "{$10^{4}$}"   1e+4,        \
        "{$10^{5}$}"   1e+5         \
        )
set xlabel "{\\Large $n_{\\rm int}$}"
set  label "[l]{\\large $T_{\\rm GC}(n_{\\rm int})$}" at graph 0.1, 0.85

plot [10:1e+5][10:1e+3] 'finite_element_cout.dat' u 2:3 notitle w lp 

