#ifdef HAVE_GINAC
#include <ginac/ginac.h>

namespace std { // std:: is required for compat with std::valarray<T>
        GiNaC::ex
        abs (GiNaC::ex value)
        {
                // return GiNaC::abs (GiNaC::ex_to<GiNaC::numeric>(value.evalf()));
                return GiNaC::abs(value);
        }
}
GiNaC::ex
eval (const GiNaC::ex& p, const GiNaC::symbol& x, const GiNaC::ex& value)
{
	return p.subs (x == value);
}
GiNaC::ex
integrate (const GiNaC::ex& p, const GiNaC::symbol& x)
{
	// ck*x^k -> (ck/(k+1))*x^{k+1}
	GiNaC::ex q = expand (p);
	size_t n = q.degree (x);
        GiNaC::ex r = 0;
        for (size_t k = 0; k <= n; k++)
            r += (q.coeff(x,k).evalf()/(k+1)) * pow (x,k+1);
	return r;
} 
#endif // HAVE_GINAC
