#include <stdlib.h>
#include <iostream>
#include "jacobi_gauss_lobatto.h"

using namespace std;

int main (int argc, char **argv) {
	unsigned int N = argc > 1 ? atoi(argv[1]) : 5;

	unsigned int ngrid = 200;
	double a = 0;
	double b = 0;
	cout << "# a = " << a << endl
	     << "# b = " << b << endl
	     << "# N = " << N << endl;
	for (unsigned int i = 0; i < ngrid+1; i++) {
	    double x = -1 + 2.0*i/(ngrid+1);
	    double p, d, p1, d1, p2, d2; 
	    jacobi (a, b, N, x, p, d, p1, d1, p2, d2);
	    cout << x << "	" << p << endl;
	}
	cout << endl;
	cout << "# gauss-lobatto nodes..." << endl;
	vector<double> xgl (N+1);
	jacobi_gauss_lobatto (a, b, N, xgl);
	cout << "# gauss-lobatto nodes" << endl;
	for (unsigned int i = 0; i < N+1; i++) {
	    double p, d, p1, d1, p2, d2; 
	    jacobi (a, b, N, xgl [i], p, d, p1, d1, p2, d2);
	    cout << xgl [i] << "	" << p << "	# P' = " << d << endl;
	}
}
