#ifndef _COURS_LEGENDRE_GAUSS_LOBATTO_H
#define _COURS_LEGENDRE_GAUSS_LOBATTO_H
//
// compute the Gauss-Lobatto collocation points and weights 
// for Legendre polynomial at order N for Omega = ]-1,1[ 
//
// the formulae is exact in P_{2N-1}
//
//  x [0:N] : the colocation points in increasing order
//  w [0:N] : the associated weights
//
// reference : C. Bernardi and Y. Maday
// Spectral methods
// Handbook for Numerical analysis, vol. 5,
// Elsevier, 1997
// pages 244-249
//
// Performances: on Legendre-Gauss-Lobatto by using bissection
//	a` peu pres ok jusqu'a N=41
//	pour N=51, la v.p. x[25]=0.00703437 au lieu de zero
//	pour N=61, x[60] = 1.00377 > 1 ... ca deconne
//	octave est meilleur...tient a` plus de 100 pour Gauss-Legendre
//
//		n = [1:N-1];
//		d = sqrt(((n.+1).^2-1)./(4*(n.+1).^2-1));
//		J = diag(d,1)+diag(d,-1);
//		r = sort(eig(sparse(J)));
//
//	=> faudrait voir ce qu'il fait avec ses valeurs propres...
//
#include "legendre_gauss_lobatto.icc"
#endif // _COURS_LEGENDRE_GAUSS_LOBATTO_H
