function r = legendre_gauss_lobatto(N);
%  compute the roots of the first derivative of the
%  Legendre polynomial of degree N.
n = [1:N-1];                   %  Indices
d = sqrt(((n.+1).^2-1)./(4*(n.+1).^2-1)); %  Create subdiagonals
J = diag(d,1)+diag(d,-1);      %  Create Jacobi matrix
r = sort(eig(sparse(J)));      %  Compute eigenvalues
