#include "legendre_gauss_lobatto.h"
#include "show.h"
#include "quadrature_check.h"
#include <vector>
using namespace std;
int main (int argc, char **argv) {

        unsigned int N = argc > 1 ? atoi(argv[1]) : 5;
	vector<double> x (N+1);
	vector<double> w (N+1);
        legendre_gauss_lobatto (x, w);

	show ("x", x, std::cout);
	std::cout << std::endl;
	show ("w", w, std::cout);

	double err = quadrature_check (x.begin(), w.begin(), N, 2*N-1);
	std::cerr << "err = " << err << std::endl;
        return err < 1e-7 ? 0 : 1;
}
