#include "legendre_gauss.h"
#include "quadrature_check.h"
#include <vector>
#include <iostream>
#include <iomanip>
#include <limits>
using namespace std;
int main (int argc, char **argv) {
        unsigned int N = argc > 1 ? atoi(argv[1]) : 5;
        bool short_format = (argc > 2);
	vector<double> x (N);
	vector<double> w (N);
        legendre_gauss (x, w);
	if (!short_format)
	    cout << std::setprecision (std::numeric_limits<double>::digits10);
	cout << "# legendre-gauss\n"
	     << "# N = "<< N << endl
	     << "# i\txi\twi\n";
	for (size_t i = 0; i < N; i++) 
	    cout << i+1 << "\t" << x[i] << "\t" << w[i] << endl;

        double err = quadrature_check (x.begin(), w.begin(), N, 2*N-1);
        std::cerr << "err = " << err << std::endl;
        return err < 1e-7 ? 0 : 1;
}
