#!/bin/sh
if test "$1" = ""; then
    n=10000
else
    n=$1
fi
if test "$2" = ""; then
    factor=2
else
    factor=$2
fi
prog=legendre_gauss_tst
i=2
echo "# $prog"
echo "# N	max_i |wi - pi*sqrt(1-xi^2)/N|"
tmp=tmp.out
while test $i -le $n; do

    $prog $i > $tmp
    awk -v N_VALUE=$i '
BEGIN 		{ erreur = 0; pi = 3.1415926535897932384626433832795029; }
/^#.*/		{ next; }
($1 == "")	{ next; }
		{
		    x = $2;
		    w = $3;
		    w_loi = pi*sqrt(1-x*x)/N_VALUE
		    err_i = w - w_loi;
		    if (err_i < 0) err_i = -err_i;
		    if (err_i > erreur) erreur = err_i
		    # print $1 " " err_i " " w_loi
		    next;
		}
END 		{ print N_VALUE " " erreur; }
	'< $tmp
    i=`echo "$i * $factor" | bc`
done
rm -f $tmp

