dnl fichier destine' au prprocesseur M4
dnl  en sortie : matrix_class.h
dnl Il existe deux versions : avec ou sans les
dnl accesseurs aux donnes internes.
dnl
dnl USAGE :
dnl     m4 matrix_class.m4 > matrix_class_m4.icc
dnl 	m4 -Daccessors=1 matrix_class.m4 > matrix_class_v2_m4.icc
dnl
changequote(%{, %})dnl
#include <valarray>
#include <iostream>
ifelse(accessors,1, %{dnl
#include "matrix_store.h"
%})dnl
template <typename T>
class matrix {
public:
    matrix ();	
    matrix (const matrix<T>&);
    matrix<T>& operator= (const matrix<T>&);
ifelse(accessors,1, %{dnl
    template <typename U> friend void convert (const matrix_store<U>&, matrix<U>&);	
%})dnl
    size_t nrow () const;
    size_t ncol () const;
    size_t nnz  () const;
ifelse(accessors,1, %{dnl
    const std::valarray<size_t>& start () const;
    const std::valarray<size_t>& index () const;
    const std::valarray<T>& value () const;
    void check () const;
    void dump (std::ostream&) const;
    template <typename U> friend class diag;
    template <typename U> friend class ssor;
    template <typename U> friend class ilu;
%})dnl
    template <typename U>
    friend std::istream& operator>> (std::istream&, matrix<U>&);
    template <typename U>
    friend std::ostream& operator<< (std::ostream&, const matrix<U>&);
    void resize (size_t nrow, size_t ncol, size_t nnz);
    std::valarray<T> operator* (const std::valarray<T>&) const;
protected:
    std::valarray<size_t> ptr;
    std::valarray<size_t> idx;
    std::valarray<T>      val;
    size_t                idxmax;
};
