#
# generates *.iplot included by nodes-*.plot
#
# usage example:
# 	legendre_gauss_tst 30 | awk -f nodes-tics-iplot.awk > nodes-tics-30.iplot
#	gnuplot nodes-30.plot
#
# -------------------
# header
# -------------------
BEGIN {
		print "# file automatically generated by"
		print "#	awk -f nodes-tics-iplot.awk < input"
		print "# for inclusion in gnuplot"
		print ""
	}
# -------------------
# skip comments
# -------------------
/^#.*/		{ next; }
($1 == "")	{ next; }

# -------------------
# read: i xi wi
# -------------------
	{
		printf ("x%d = %s\n", $1, $2); 
		printf ("set label \"{$\\\\xi_{%d}$}\" at x%d, -0.05\n", $1, $1);
		printf ("set label \"{$\\\\theta_{%d}$}\" at 1.05*x%d, 1.05*sin(acos(x%d))\n", $1, $1, $1);
		printf ("\n");
	}

