#include "rad.h"
using namespace std;
template <typename T>
T func(const T& x, const T& y) {
  T z = sqrt(x);
  return y*z+sin(z);
}
void test1 () {
  std::valarray<rad<double> > x(2);
  x[0] = 2;
  x[1] = 3;
  std::valarray<rad<double> > f(1);
  f[0] = func(x[0],x[1]);
  dense_matrix<double> df_dx;
  reverse_diff (f,x,df_dx);
  cout << "-- test 1 --" << endl;
  cout << "x=" << x[0].value() << endl;
  cout << "y=" << x[1].value() << endl;
  cout << "f=" << f[0].value() << endl;
  cout << "df/dx(x,y)=" << df_dx(0,0) << endl;
  cout << "df/dy(x,y)=" << df_dx(0,1) << endl;
}
void test2 () {
  std::valarray<rad<double> > x(2);
  x[0] = 2;
  x[1] = 3;
  std::valarray<rad<double> > f(2);
  rad<double> tmp = x[0]*x[1];
  f[0] = tmp*x[1];
  f[1] = tmp*x[0];
  dense_matrix<double> df_dx;
  reverse_diff (f,x,df_dx); 
  cout << "-- test 2 --" << endl;
  cout << "x0=" << x[0].value() << endl;
  cout << "x1=" << x[1].value() << endl;
  cout << "f0=" << f[0].value() << endl;
  cout << "f1=" << f[1].value() << endl;
  cout << "df0/dx0(x,y)=" << df_dx(0,0) << endl;
  cout << "df0/dx1(x,y)=" << df_dx(0,1) << endl;
  cout << "df1/dx0(x,y)=" << df_dx(1,0) << endl;
  cout << "df1/dx1(x,y)=" << df_dx(1,1) << endl;
}
int main () {
  test1();
  test2();
}
