set terminal latex
set output "spectral-cg-1d.tex"

set logscale y
set ytics nomirror (                             \
        "[r]{$10^{-16}$}"   1e-16,        \
        "[r]{$10^{-12}$}"   1e-12,        \
        "[r]{$10^{-8}$}"   1e-8,        \
        "[r]{$10^{-4}$}"   1e-4,       \
        "[r]{$1$}"   1       \
        )
set xtics nomirror (0, 100, 200, 300)

set xlabel "{\\large $i$}"
set  label "[r]{\\large $\\|r^{(i)}\\|$}" at graph -0.12, 0.60

plot [0:300][5e-17:100] \
	'spectral-cg-n=128-1d.dat' u 2:3 title "[r]{$N=128$}"      w l lt 3 pt 17, \
	'spectral-cg-n=64-1d.dat'  u 2:3 title "[r]{$N=64$\\,\\ }" w l lt 1 pt 10, \
	'spectral-cg-n=32-1d.dat'  u 2:3 title "[r]{$N=32$\\,\\ }" w l lt 4 pt  6

#pause -1 "<retour>"

