set terminal latex
set output "spectral-cond-a.tex"

set size square
set logscale
set xtics (                             \
        "[r]{$10^{3}$}"   1e3,        \
        "[r]{$10^{2}$}"   1e2,        \
        "[r]{$10^{1}$}"   1e+1,        \
        "[r]{$1$}"   	  1        \
        )
set ytics (                             \
        "[r]{$10^{9}$}"   1e9,        \
        "[r]{$10^{6}$}"   1e6,        \
        "[r]{$10^{3}$}"   1e+3,        \
        "[r]{$1$}"   	  1        \
        )

set xlabel "{\\large $N$}"
set  label "[r]{\\large ${\\rm cond}(A)$}" at graph -0.12, 0.50

plot [1:1e3][1:1e9] 'spectral-cond-a.dat' notitle w lp

