set terminal pslatex
set output "spectral-cvg-log-fit.tex"

# a               = 0.332844
# b               = 1
# c               = 1
a               = 0.270376    #    +/- 0.01342      (4.965%)
b               = 0.451983    #    +/- 0.05107      (11.3%)
c               = -0.589247   #    +/- 0.2044       (34.68%)
f(x) = -a*x*log(x) + b*x + c
# fit [5:30] f(x) 'spectral-cvg-log-k=5.dat' u 1:2 via a,b,c

set xtics nomirror (0, 10, 20, 30, 40)
set ytics nomirror (\
        "[r]{$1$}"              0, \
        "[r]{$10^{-4}$}"        -4, \
        "[r]{$10^{-8}$}"        -8, \
        "[r]{$10^{-12}$}"       -12, \
        "[r]{$10^{-16}$}"       -16 \
        )
set xlabel "{\\large $N$}"
set  label "[r]{\\large $\\|u_N-\\pi_N u\\|_{L^\\infty}$}" at graph -0.11,0.65

plot [][-20:1]\
	 'spectral-cvg-log-k=5.dat' u 1:2 notitle w p lt 1 pt 1, \
	 f(x) notitle w l lt 1


# pause -1 "<retour>"

