// T(n) = O(n^2)
template <typename Polynom, typename Symbol, typename T>
T scalar_product (const Polynom& u, const Polynom& v, const Symbol& x,
		const T& a, const T& b)
{
    	Polynom primitive = integrate (u*v, x);
    	return eval (primitive, x, b) - eval (primitive, x, a);
}
// T(n) = O(n^4)
template <typename PolynomContainer, typename Symbol, typename Matrix, typename T>
void
spectral_bilinear_form (const PolynomContainer& L, const Symbol& x, 
		const T& a, const T& b, Matrix& m)
{
	m.resize (L.size(), L.size());
  	for (unsigned int i = 0; i < L.size(); i++)
  	    for (unsigned int j = 0; j < L.size(); j++)
              m.entry (i,j) = scalar_product (L[i], L[j], x, a, b);
}
