template <typename Valarray, typename DenseMatrix>
void
spectral_boundary_condition (DenseMatrix& a, Valarray& b)
{
    const unsigned int n = a.nrow()-1;
    for (size_t i = 0; i <= n; i++) {
      a.entry (0,i) = 0;
      a.entry (i,0) = 0;
      a.entry (n,i) = 0;
      a.entry (i,n) = 0;
    }
    a.entry (0,0) = 1;
    a.entry (n,n) = 1;
    b [0]   = 0;
    b [n]   = 0;
}

